#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Green
#property indicator_color4 White

//---- input parameters
extern int RSIPeriod1=14;
extern int RSIPeriod2=8;
extern int RSIPeriod3=5;
extern int RSIPeriod4=3;
extern int EMA=3;
//---- buffers
double RSIBuffer1[];
double RSIBuffer2[];
double RSIBuffer3[];
double RSIBuffer4[];
//----   
double PosBuffer1[];
double NegBuffer1[];
double PosBuffer2[];
double NegBuffer2[];
double PosBuffer3[];
double NegBuffer3[];
double PosBuffer4[];
double NegBuffer4[];
//+------------------------------------------------------------------+
//| SetAsIndexBuffer() function                                      |
//+------------------------------------------------------------------+
   void SetAsIndexBuffer()   {
  int NewSize=Bars;
  if(ArraySize(PosBuffer1) < NewSize)   {
      //----       
      ArraySetAsSeries(PosBuffer1, false);
      ArraySetAsSeries(NegBuffer1, false);
      ArraySetAsSeries(PosBuffer2, false);
      ArraySetAsSeries(NegBuffer2, false);
      ArraySetAsSeries(PosBuffer3, false);
      ArraySetAsSeries(NegBuffer3, false);
      ArraySetAsSeries(PosBuffer4, false);
      ArraySetAsSeries(NegBuffer4, false);
      
      ArrayResize(PosBuffer1, NewSize); 
      ArrayResize(NegBuffer1, NewSize); 
      ArrayResize(PosBuffer2, NewSize);
      ArrayResize(NegBuffer2, NewSize);
      ArrayResize(PosBuffer3, NewSize); 
      ArrayResize(NegBuffer3, NewSize); 
      ArrayResize(PosBuffer4, NewSize);
      ArrayResize(NegBuffer4, NewSize);
      
      ArraySetAsSeries(PosBuffer1, true);
      ArraySetAsSeries(NegBuffer1, true);
      ArraySetAsSeries(PosBuffer2, true);
      ArraySetAsSeries(NegBuffer2, true);
      ArraySetAsSeries(PosBuffer3, true);
      ArraySetAsSeries(NegBuffer3, true);
      ArraySetAsSeries(PosBuffer4, true);
      ArraySetAsSeries(NegBuffer4, true);
       
    } 
//----
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 8 additional buffers are used for counting.
   
   //---- indicator lines
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSIBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,RSIBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,RSIBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,RSIBuffer4);

//---- name for DataWindow and indicator subwindow label
   short_name="RSI-multi("+RSIPeriod1+", "+RSIPeriod2+", "+RSIPeriod3+", "+RSIPeriod4+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,RSIPeriod1);
   SetIndexDrawBegin(1,RSIPeriod2);
   SetIndexDrawBegin(2,RSIPeriod3);
   SetIndexDrawBegin(3,RSIPeriod4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
   double rel,negative1,positive1,negative2,positive2,negative3,positive3,negative4,positive4;
//----
   if(Bars<=RSIPeriod1) return(0);
   //----    
   SetAsIndexBuffer();
   //---- initial zero
   if(counted_bars<1)
      for(i=1;i<=RSIPeriod1;i++) RSIBuffer1[Bars-i]=0.0;
                                  
   //----
   i=Bars-RSIPeriod1-1;
   if(counted_bars>=RSIPeriod1) i=Bars-counted_bars-1;
   while(i>=0)
     {
     double sumn=0.0,sump=0.0;
     if(i==Bars-RSIPeriod1-1)
       {
         int k=Bars-2;
         //---- initial accumulation
         while(k>=i)
           {
            rel=(iMA(NULL,0,EMA,0,MODE_EMA,PRICE_MEDIAN,k)-iMA(NULL,0,EMA,0,MODE_EMA,PRICE_MEDIAN,k+1));
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive1=sump/RSIPeriod1; 
         negative1=sumn/RSIPeriod1;
         positive2=sump/RSIPeriod2; 
         negative2=sumn/RSIPeriod2;
         positive3=sump/RSIPeriod3; 
         negative3=sumn/RSIPeriod3;
         positive4=sump/RSIPeriod4; 
         negative4=sumn/RSIPeriod4;
        }
      else
        {
         //---- smoothed moving average
         rel=(iMA(NULL,0,EMA,0,MODE_EMA,PRICE_MEDIAN,i)-iMA(NULL,0,EMA,0,MODE_EMA,PRICE_MEDIAN,i+1));
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive1=(PosBuffer1[i+1]*(RSIPeriod1-1)+sump)/RSIPeriod1;
         negative1=(NegBuffer1[i+1]*(RSIPeriod1-1)+sumn)/RSIPeriod1;
         positive2=(PosBuffer2[i+1]*(RSIPeriod2-1)+sump)/RSIPeriod2;
         negative2=(NegBuffer2[i+1]*(RSIPeriod2-1)+sumn)/RSIPeriod2;
         positive3=(PosBuffer3[i+1]*(RSIPeriod3-1)+sump)/RSIPeriod3;
         negative3=(NegBuffer3[i+1]*(RSIPeriod3-1)+sumn)/RSIPeriod3;
         positive4=(PosBuffer4[i+1]*(RSIPeriod4-1)+sump)/RSIPeriod4;
         negative4=(NegBuffer4[i+1]*(RSIPeriod4-1)+sumn)/RSIPeriod4;
        }
      PosBuffer1[i]=positive1;
      NegBuffer1[i]=negative1;
      PosBuffer2[i]=positive2;
      NegBuffer2[i]=negative2;
      PosBuffer3[i]=positive3;
      NegBuffer3[i]=negative3;
      PosBuffer4[i]=positive4;
      NegBuffer4[i]=negative4;
      if(negative1==0.0) RSIBuffer1[i]=0.0;
      else RSIBuffer1[i]=100.0-100.0/(1+positive1/(negative1+0.000000000000000000000000000000000000001));
      if(negative2==0.0) RSIBuffer2[i]=0.0;
      else RSIBuffer2[i]=100.0-100.0/(1+positive2/(negative2+0.000000000000000000000000000000000000001));
      if(negative3==0.0) RSIBuffer3[i]=0.0;
      else RSIBuffer3[i]=100.0-100.0/(1+positive3/(negative3+0.000000000000000000000000000000000000001));
      if(negative4==0.0) RSIBuffer4[i]=0.0;
      else RSIBuffer4[i]=100.0-100.0/(1+positive4/(negative4+0.000000000000000000000000000000000000001));
           
      i--;     }
return(0);  }
//+------------------------------------------------------------------+


